#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2800three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2800three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three28004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three28004xi = {
                1:'0x2717y-673z',
                2:'1015x2392y-1041z',
                3:'1031x2032y-1625z',
                4:'1034x2221y-1354z',
                5:'107x257y-2786z',
                6:'111x732y-2700z',
                7:'1123x2524y-453z',
                8:'112x2215y-1867z',
                9:'1143x2345y-1015z',
                10:'1144x1989y-1603z',
                11:'1155x2176y-1329z',
                12:'117x103y-2795z',
                13:'1255x1940y-1580z',
                14:'1256x2465y-426z',
                15:'1269x2291y-989z',
                16:'1274x2124y-1304z',
                17:'132x276y-2783z',
                18:'1364x1885y-1556z',
                19:'1385x2400y-398z',
                20:'1391x2065y-1280z',
                21:'1393x2229y-962z',
                22:'142x2720y-645z',
                23:'144x114y-2793z',
                24:'1471x1823y-1533z',
                25:'1505x1999y-1255z',
                26:'1511x2327y-370z',
                27:'1513x2161y-936z',
                28:'155x752y-2692z',
                29:'1574x1754y-1509z',
                30:'160x293y-2779z',
                31:'1615x1927y-1230z',
                32:'162x2344y-1522z',
                33:'1630x2086y-910z',
                34:'1633x2248y-342z',
                35:'1675x1680y-1486z',
                36:'1722x1849y-1204z',
                37:'173x123y-2791z',
                38:'1743x2005y-883z',
                39:'1750x2162y-315z',
                40:'1771x1600y-1462z',
                41:'1825x1765y-1179z',
                42:'1851x1917y-856z',
                43:'1863x2069y-287z',
                44:'1864x1514y-1438z',
                45:'18x138y-2796z',
                46:'190x308y-2776z',
                47:'1924x1674y-1154z',
                48:'1952x1423y-1414z',
                49:'1955x1823y-830z',
                50:'1971x1971y-259z',
                51:'2018x1578y-1128z',
                52:'201x769y-2684z',
                53:'2054x1724y-803z',
                54:'2073x1867y-231z',
                55:'2107x1477y-1102z',
                56:'2148x1618y-776z',
                57:'2170x1757y-203z',
                58:'220x2522y-1195z',
                59:'221x320y-2772z',
                60:'222x2148y-1781z',
                61:'2236x1508y-749z',
                62:'2260x1642y-175z',
                63:'249x783y-2676z',
                64:'255x330y-2768z',
                65:'26x35y-2799z',
                66:'285x2715y-618z',
                67:'287x2347y-1498z',
                68:'290x337y-2764z',
                69:'299x794y-2668z',
                70:'2x83y-2798z',
                71:'30x164y-2794z',
                72:'326x342y-2759z',
                73:'32x686y-2714z',
                74:'337x2151y-1759z',
                75:'351x801y-2659z',
                76:'354x2519y-1169z',
                77:'364x343y-2754z',
                78:'39x2334y-1545z',
                79:'402x341y-2749z',
                80:'404x806y-2650z',
                81:'412x2344y-1474z',
                82:'428x2703y-591z',
                83:'441x337y-2744z',
                84:'453x2148y-1737z',
                85:'459x806y-2641z',
                86:'46x189y-2793z',
                87:'46x56y-2799z',
                88:'481x328y-2738z',
                89:'487x2508y-1144z',
                90:'515x803y-2632z',
                91:'537x2333y-1451z',
                92:'569x2138y-1715z',
                93:'570x2682y-563z',
                94:'572x797y-2622z',
                95:'620x2490y-1118z',
                96:'629x786y-2612z',
                97:'63x213y-2791z',
                98:'662x2316y-1427z',
                99:'685x2121y-1693z',
                100:'687x771y-2602z',
                101:'68x74y-2798z',
                102:'70x710y-2707z',
                103:'711x2654y-536z',
                104:'744x753y-2591z',
                105:'753x2465y-1092z',
                106:'787x2291y-1402z',
                107:'801x2098y-1671z',
                108:'802x730y-2581z',
                109:'84x236y-2788z',
                110:'850x2618y-509z',
                111:'859x704y-2570z',
                112:'87x2518y-1220z',
                113:'885x2432y-1067z',
                114:'911x2260y-1378z',
                115:'915x673y-2558z',
                116:'917x2068y-1648z',
                117:'91x90y-2797z',
                118:'970x638y-2547z',
                119:'988x2575y-481z',
                120:'9x110y-2797z',
                121:'9x13y-2799z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2800three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2800three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2800THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2800THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2800THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2800THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2800THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three28004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2800THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2800THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2800THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three28004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three28004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2800THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2800THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2800THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2800three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                